.align 4
.code 32
.global main
@==================================================================================================
error:
	bl		writestring
	mov	r15,r6
@==================================================================================================
flags_zc:
	bne	error
	bcc	error
	bmi	error
	bvs	error
	mov	r15,r14
flags_n:
	beq	error
	bcs	error
	bpl	error
	bvs	error
	mov	r15,r14
flags_c:
	beq	error
	bcc	error
	bmi	error
	bvs	error
	mov	r15,r14
flags_cv:
	beq	error
	bcc	error
	bmi	error
	bvc	error
	mov	r15,r14
@==================================================================================================
checkregs_arm:
	cmp	r0,#0
	cmpeq	r1,#1
	cmpeq	r2,#2
	cmpeq	r3,#4
	cmpeq	r4,#0x7000
	cmpeq	r5,#0xf000
	bne	error
	mov	r15,r14
@==================================================================================================
cmpregtest:
	mov	r6,r14
	mov	r8,#0x80000000
	cmp	r0,r0
	bl		flags_zc
	cmp	r1,r1
	bl		flags_zc
	cmp	r0,r1
	bl		flags_n
	cmp	r1,r0
	bl		flags_c
	cmp	r0,r2
	bl		flags_n
	cmp	r2,r0
	bl		flags_c
	cmp	r2,r1
	bl		flags_c
	cmp	r8,r1
	bl		flags_cv
	mov	r15,r6
@==================================================================================================
cmpimmtest:
	mov	r6,r14
	mov	r8,#0x80000000
	cmp	r0,#0
	bl		flags_zc
	cmp	r1,#1
	bl		flags_zc
	cmp	r0,#1
	bl		flags_n
	cmp	r1,#0
	bl		flags_c
	cmp	r0,#2
	bl		flags_n
	cmp	r2,#0
	bl		flags_c
	cmp	r2,#1
	bl		flags_c
	cmp	r8,#1
	bl		flags_cv
	mov	r15,r6
@==================================================================================================
teqregtest:
	mov	r6,r14
	mov	r8,#0xffffffff
	teq	r0,r0
	bne	error
	teq	r1,r1
	bne	error
	teq	r0,r8
	bpl	error
	mov	r15,r6
@==================================================================================================
teqimmtest:
	mov	r6,r14
	mov	r8,#0x80000000
	teq	r0,#0
	bne	error
	teq	r1,#1
	bne	error
	teq	r0,#0x80000000
	bpl	error
	mov	r15,r6
@==================================================================================================
ldrtest:
	stmia	r13!,{r0,r1,r2,r3,r4,r5,r6,r7}
	ldr	r0,offset0
	ldr	r1,offset1
	ldr	r2,offset2
	ldr	r3,offset3
	mov	r4,#0x11000000
	mov	r5,#0x22000000
	mov	r6,#0x33000000
	mov	r7,#0x44000000
	orr	r6,r6,r7,lsr #8
	orr	r5,r5,r6,lsr #8
	orr	r4,r4,r5,lsr #8
	mov	r7,r7,lsr #24
	mov	r6,r6,lsr #16
	mov	r5,r5,lsr #8
	cmp	r0,r4
	cmpeq	r1,r5
	cmpeq	r2,r6
	cmpeq	r3,r7
	ldmdb	r13!,{r0,r1,r2,r3,r4,r5,r6,r7}
	bne	error
	mov	r15,r6
.align 4
values:
	.word 0x11223344
	.word 0x22334400
	.word 0x33440000
	.word 0x44000000
.align 4
offset0:
	.word	0x11223344
.align 4
	.byte 0x00
offset1:
	.word	0x11223344
.align 4
	.byte 0x00,00
offset2:
	.word	0x11223344
.align 4
	.byte 0x00,0x00,0x00
offset3:
	.word	0x11223344
.align 4
@==================================================================================================
stmia_ldmdbtest:
	mov	r6,r14
	stmia	r13!,{r0,r1,r2,r3,r4,r5}
	ldmdb	r13!,{r0,r1,r2,r3,r4,r5}
	bl		checkregs_arm
	mov	r15,r6
@==================================================================================================
stmib_ldmdatest:
	mov	r6,r14
	stmib	r13!,{r0,r1,r2,r3,r4,r5}
	ldmda	r13!,{r0,r1,r2,r3,r4,r5}
	bl		checkregs_arm
	mov	r15,r6
@==================================================================================================
stmda_ldmibtest:
	mov	r6,r14
	stmda	r13!,{r0,r1,r2,r3,r4,r5}
	ldmib	r13!,{r0,r1,r2,r3,r4,r5}
	bl		checkregs_arm
	mov	r15,r6
@==================================================================================================
stmdb_ldmiatest:
	mov	r6,r14
	stmdb	r13!,{r0,r1,r2,r3,r4,r5}
	ldmia	r13!,{r0,r1,r2,r3,r4,r5}
	bl		checkregs_arm
	mov	r15,r6
@==================================================================================================
ldrstrcheckregs:
	mov	r7,#0x00000078
	orr	r7,r7,#0x00120000
	cmp	r8,r5
	cmpeq	r9,r7
	bne	error
	mov	r15,r14
@==================================================================================================
ldrbstrbcheckregs:
	cmp	r8,r2
	cmpeq	r9,r3
	bne	error
	mov	r15,r14
@==================================================================================================
strtrashregs:
	mvn	r8,r13
	mvn	r9,r13
	mov	r15,r14
@==================================================================================================
ldrpreimmuptest:
	mov	r6,r14
	ldr	r7,=unalignedwords
	ldr	r8,[r7]
	ldr	r9,[r7,#4]
	bl		ldrstrcheckregs
	mov	r15,r6
@==================================================================================================
ldrpreimmdowntest:
	mov	r6,r14
	ldr	r7,=unalignedwords
	add	r7,r7,#4
	ldr	r9,[r7]
	ldr	r8,[r7,#-4]
	bl		ldrstrcheckregs
	mov	r15,r6
@==================================================================================================
ldrprereguptest:
	mov	r6,r14
	ldr	r7,=unalignedwords
	ldr	r8,[r7]
	ldr	r9,[r7,r3]
	bl		ldrstrcheckregs
	mov	r15,r6
@==================================================================================================
ldrpreregdowntest:
	mov	r6,r14
	ldr	r7,=unalignedwords
	add	r7,r7,#4
	ldr	r9,[r7]
	ldr	r8,[r7,-r3]
	bl		ldrstrcheckregs
	mov	r15,r6
@==================================================================================================
ldrpreimmupwbtest:
	mov	r6,r14
	ldr	r7,=unalignedwords
	sub	r7,r7,#4
	ldr	r8,[r7,#4]!
	ldr	r9,[r7,#4]
	bl		ldrstrcheckregs
	mov	r15,r6
@==================================================================================================
ldrpreimmdownwbtest:
	mov	r6,r14
	ldr	r7,=unalignedwords
	add	r7,r7,#8
	ldr	r9,[r7,#-4]!
	ldr	r8,[r7,#-4]
	bl		ldrstrcheckregs
	mov	r15,r6
@==================================================================================================
ldrpreregupwbtest:
	mov	r6,r14
	ldr	r7,=unalignedwords
	sub	r7,r7,#4
	ldr	r8,[r7,r3]!
	ldr	r9,[r7,r3]
	bl		ldrstrcheckregs
	mov	r15,r6
@==================================================================================================
ldrpreregdownwbtest:
	mov	r6,r14
	ldr	r7,=unalignedwords
	add	r7,r7,#8
	ldr	r9,[r7,-r3]!
	ldr	r8,[r7,-r3]
	bl		ldrstrcheckregs
	mov	r15,r6
@==================================================================================================
ldrpostimmuptest:
	mov	r6,r14
	ldr	r7,=unalignedwords
	ldr	r8,[r7],#4
	ldr	r9,[r7]
	bl		ldrstrcheckregs
	mov	r15,r6
@==================================================================================================
ldrpostimmdowntest:
	mov	r6,r14
	ldr	r7,=unalignedwords
	add	r7,r7,#4
	ldr	r9,[r7],#-4
	ldr	r8,[r7]
	bl		ldrstrcheckregs
	mov	r15,r6
@==================================================================================================
ldrpostreguptest:
	mov	r6,r14
	ldr	r7,=unalignedwords
	ldr	r8,[r7],r3
	ldr	r9,[r7]
	bl		ldrstrcheckregs
	mov	r15,r6
@==================================================================================================
ldrpostregdowntest:
	mov	r6,r14
	ldr	r7,=unalignedwords
	add	r7,r7,#4
	ldr	r9,[r7],-r3
	ldr	r8,[r7]
	bl		ldrstrcheckregs
	mov	r15,r6
@==================================================================================================
strpreimmuptest:
	mov	r6,r14
	ldr	r7,=unalignedwords
	ldr	r8,[r7]
	ldr	r9,[r7,#4]
	str	r8,[r13]
	str	r9,[r13,#4]
	bl		strtrashregs
	ldr	r8,[r13]
	ldr	r9,[r13,#4]
	bl		ldrstrcheckregs
	mov	r15,r6
@==================================================================================================
strpreimmdowntest:
	mov	r6,r14
	ldr	r7,=unalignedwords
	add	r7,r7,#4
	ldr	r9,[r7]
	ldr	r8,[r7,#-4]
	str	r9,[r13]
	str	r8,[r13,#-4]
	bl		strtrashregs
	ldr	r9,[r13]
	ldr	r8,[r13,#-4]
	bl		ldrstrcheckregs
	mov	r15,r6
@==================================================================================================
strprereguptest:
	mov	r6,r14
	ldr	r7,=unalignedwords
	ldr	r8,[r7]
	ldr	r9,[r7,r3]
	str	r8,[r13]
	str	r9,[r13,r3]
	bl		strtrashregs
	ldr	r8,[r13]
	ldr	r9,[r13,r3]
	bl		ldrstrcheckregs
	mov	r15,r6
@==================================================================================================
strpreregdowntest:
	mov	r6,r14
	ldr	r7,=unalignedwords
	add	r7,r7,#4
	ldr	r9,[r7]
	ldr	r8,[r7,-r3]
	str	r9,[r13]
	str	r8,[r13,-r3]
	bl		strtrashregs
	ldr	r9,[r13]
	ldr	r8,[r13,-r3]
	bl		ldrstrcheckregs
	mov	r15,r6
@==================================================================================================
strpreimmupwbtest:
	mov	r6,r14
	ldr	r7,=unalignedwords
	sub	r7,r7,#4
	ldr	r8,[r7,#4]!
	ldr	r9,[r7,#4]
	str	r8,[r13,#4]!
	str	r9,[r13,#4]
	bl		strtrashregs
	sub	r13,r13,#4
	ldr	r8,[r13,#4]!
	ldr	r9,[r13,#4]
	bl		ldrstrcheckregs
	mov	r15,r6
@==================================================================================================
strpreimmdownwbtest:
	mov	r6,r14
	ldr	r7,=unalignedwords
	add	r7,r7,#8
	ldr	r9,[r7,#-4]!
	ldr	r8,[r7,#-4]
	str	r9,[r13,#-4]!
	str	r8,[r13,#-4]
	bl		strtrashregs
	add	r13,r13,#4
	ldr	r9,[r13,#-4]!
	ldr	r8,[r13,#-4]
	bl		ldrstrcheckregs
	mov	r15,r6
@==================================================================================================
strpreregupwbtest:
	mov	r6,r14
	ldr	r7,=unalignedwords
	sub	r7,r7,#4
	ldr	r8,[r7,r3]!
	ldr	r9,[r7,r3]
	str	r8,[r13,r3]!
	str	r9,[r13,r3]
	bl		strtrashregs
	sub	r13,r13,#4
	ldr	r8,[r13,r3]!
	ldr	r9,[r13,r3]
	bl		ldrstrcheckregs
	mov	r15,r6
@==================================================================================================
strpreregdownwbtest:
	mov	r6,r14
	ldr	r7,=unalignedwords
	add	r7,r7,#8
	ldr	r9,[r7,-r3]!
	ldr	r8,[r7,-r3]
	str	r8,[r13,-r3]!
	str	r9,[r13,-r3]
	bl		strtrashregs
	add	r13,r13,#4
	ldr	r8,[r13,-r3]!
	ldr	r9,[r13,-r3]
	bl		ldrstrcheckregs
	mov	r15,r6
@==================================================================================================
strpostimmuptest:
	mov	r6,r14
	ldr	r7,=unalignedwords
	ldr	r8,[r7],#4
	ldr	r9,[r7]
	str	r8,[r13],#4
	str	r9,[r13]
	bl		strtrashregs
	sub	r13,r13,#4
	ldr	r8,[r13],#4
	ldr	r9,[r13]
	bl		ldrstrcheckregs
	mov	r15,r6
@==================================================================================================
strpostimmdowntest:
	mov	r6,r14
	ldr	r7,=unalignedwords
	add	r7,r7,#4
	ldr	r9,[r7],#-4
	ldr	r8,[r7]
	str	r9,[r13],#-4
	str	r8,[r13]
	bl		strtrashregs
	add	r13,r13,#4
	ldr	r9,[r13],#-4
	ldr	r8,[r13]
	bl		ldrstrcheckregs
	mov	r15,r6
@==================================================================================================
strpostreguptest:
	mov	r6,r14
	ldr	r7,=unalignedwords
	ldr	r8,[r7],r3
	ldr	r9,[r7]
	str	r8,[r13],r3
	str	r9,[r13]
	bl		strtrashregs
	sub	r13,r13,#4
	ldr	r8,[r13],r3
	ldr	r9,[r13]
	bl		ldrstrcheckregs
	mov	r15,r6
@==================================================================================================
strpostregdowntest:
	mov	r6,r14
	ldr	r7,=unalignedwords
	add	r7,r7,#4
	ldr	r9,[r7],-r3
	ldr	r8,[r7]
	str	r9,[r13],-r3
	str	r8,[r13]
	bl		strtrashregs
	add	r13,r13,#4
	ldr	r9,[r13],-r3
	ldr	r8,[r13]
	bl		ldrstrcheckregs
	mov	r15,r6
@==================================================================================================
ldrbpreimmuptest:
	mov	r6,r14
	ldr	r7,=unsignedbytes
	ldrb	r8,[r7]
	ldrb	r9,[r7,#1]
	bl		ldrbstrbcheckregs
	mov	r15,r6
@==================================================================================================
ldrbpreimmdowntest:
	mov	r6,r14
	ldr	r7,=unsignedbytes
	add	r7,r7,#1
	ldrb	r9,[r7]
	ldrb	r8,[r7,#-1]
	bl		ldrbstrbcheckregs
	mov	r15,r6
@==================================================================================================
ldrbprereguptest:
	mov	r6,r14
	ldr	r7,=unsignedbytes
	ldrb	r8,[r7]
	ldrb	r9,[r7,r1]
	bl		ldrbstrbcheckregs
	mov	r15,r6
@==================================================================================================
ldrbpreregdowntest:
	mov	r6,r14
	ldr	r7,=unsignedbytes
	add	r7,r7,#1
	ldrb	r9,[r7]
	ldrb	r8,[r7,-r1]
	bl		ldrbstrbcheckregs
	mov	r15,r6
@==================================================================================================
ldrbpreimmupwbtest:
	mov	r6,r14
	ldr	r7,=unsignedbytes
	sub	r7,r7,#1
	ldrb	r8,[r7,#1]!
	ldrb	r9,[r7,#1]
	bl		ldrbstrbcheckregs
	mov	r15,r6
@==================================================================================================
ldrbpreimmdownwbtest:
	mov	r6,r14
	ldr	r7,=unsignedbytes
	add	r7,r7,#2
	ldrb	r9,[r7,#-1]!
	ldrb	r8,[r7,#-1]
	bl		ldrbstrbcheckregs
	mov	r15,r6
@==================================================================================================
ldrbpreregupwbtest:
	mov	r6,r14
	ldr	r7,=unsignedbytes
	sub	r7,r7,#1
	ldrb	r8,[r7,r1]!
	ldrb	r9,[r7,r1]
	bl		ldrbstrbcheckregs
	mov	r15,r6
@==================================================================================================
ldrbpreregdownwbtest:
	mov	r6,r14
	ldr	r7,=unsignedbytes
	add	r7,r7,#2
	ldrb	r9,[r7,-r1]!
	ldrb	r8,[r7,-r1]
	bl		ldrbstrbcheckregs
	mov	r15,r6
@==================================================================================================
ldrbpostimmuptest:
	mov	r6,r14
	ldr	r7,=unsignedbytes
	ldrb	r8,[r7],#1
	ldrb	r9,[r7]
	bl		ldrbstrbcheckregs
	mov	r15,r6
@==================================================================================================
ldrbpostimmdowntest:
	mov	r6,r14
	ldr	r7,=unsignedbytes
	add	r7,r7,#1
	ldrb	r9,[r7],#-1
	ldrb	r8,[r7]
	bl		ldrbstrbcheckregs
	mov	r15,r6
@==================================================================================================
ldrbpostreguptest:
	mov	r6,r14
	ldr	r7,=unsignedbytes
	ldrb	r8,[r7],r1
	ldrb	r9,[r7]
	bl		ldrbstrbcheckregs
	mov	r15,r6
@==================================================================================================
ldrbpostregdowntest:
	mov	r6,r14
	ldr	r7,=unsignedbytes
	add	r7,r7,#1
	ldrb	r9,[r7],-r1
	ldrb	r8,[r7]
	bl		ldrbstrbcheckregs
	mov	r15,r6
@==================================================================================================
strbpreimmuptest:
	mov	r6,r14
	ldr	r7,=unsignedbytes
	ldrb	r8,[r7]
	ldrb	r9,[r7,#1]
	strb	r8,[r13]
	strb	r9,[r13,#1]
	bl		strtrashregs
	ldrb	r8,[r13]
	ldrb	r9,[r13,#1]
	bl		ldrbstrbcheckregs
	mov	r15,r6
@==================================================================================================
strbpreimmdowntest:
	mov	r6,r14
	ldr	r7,=unsignedbytes
	add	r7,r7,#1
	ldrb	r9,[r7]
	ldrb	r8,[r7,#-1]
	strb	r9,[r13]
	strb	r8,[r13,#-1]
	bl		strtrashregs
	ldrb	r9,[r13]
	ldrb	r8,[r13,#-1]
	bl		ldrbstrbcheckregs
	mov	r15,r6
@==================================================================================================
strbprereguptest:
	mov	r6,r14
	ldr	r7,=unsignedbytes
	ldrb	r8,[r7]
	ldrb	r9,[r7,r1]
	strb	r8,[r13]
	strb	r9,[r13,r1]
	bl		strtrashregs
	ldrb	r8,[r13]
	ldrb	r9,[r13,r1]
	bl		ldrbstrbcheckregs
	mov	r15,r6
@==================================================================================================
strbpreregdowntest:
	mov	r6,r14
	ldr	r7,=unsignedbytes
	add	r7,r7,#1
	ldrb	r9,[r7]
	ldrb	r8,[r7,-r1]
	strb	r9,[r13]
	strb	r8,[r13,-r1]
	bl		strtrashregs
	ldrb	r9,[r13]
	ldrb	r8,[r13,-r1]
	bl		ldrbstrbcheckregs
	mov	r15,r6
@==================================================================================================
strbpreimmupwbtest:
	mov	r6,r14
	ldr	r7,=unsignedbytes
	sub	r7,r7,#1
	ldrb	r8,[r7,#1]!
	ldrb	r9,[r7,#1]
	strb	r8,[r13,#1]!
	strb	r9,[r13,#1]
	bl		strtrashregs
	sub	r13,r13,#1
	ldrb	r8,[r13,#1]!
	ldrb	r9,[r13,#1]
	bl		ldrbstrbcheckregs
	mov	r15,r6
@==================================================================================================
strbpreimmdownwbtest:
	mov	r6,r14
	ldr	r7,=unsignedbytes
	add	r7,r7,#2
	ldrb	r9,[r7,#-1]!
	ldrb	r8,[r7,#-1]
	strb	r9,[r13,#-1]!
	strb	r8,[r13,#-1]
	bl		strtrashregs
	add	r13,r13,#1
	ldrb	r9,[r13,#-1]!
	ldrb	r8,[r13,#-1]
	bl		ldrbstrbcheckregs
	mov	r15,r6
@==================================================================================================
strbpreregupwbtest:
	mov	r6,r14
	ldr	r7,=unsignedbytes
	sub	r7,r7,#1
	ldrb	r8,[r7,r1]!
	ldrb	r9,[r7,r1]
	strb	r8,[r13,r1]!
	strb	r9,[r13,r1]
	bl		strtrashregs
	sub	r13,r13,#1
	ldrb	r8,[r13,r1]!
	ldrb	r9,[r13,r1]
	bl		ldrbstrbcheckregs
	mov	r15,r6
@==================================================================================================
strbpreregdownwbtest:
	mov	r6,r14
	ldr	r7,=unsignedbytes
	add	r7,r7,#2
	ldrb	r9,[r7,-r1]!
	ldrb	r8,[r7,-r1]
	strb	r8,[r13,-r1]!
	strb	r9,[r13,-r1]
	bl		strtrashregs
	add	r13,r13,#1
	ldrb	r8,[r13,-r1]!
	ldrb	r9,[r13,-r1]
	bl		ldrbstrbcheckregs
	mov	r15,r6
@==================================================================================================
strbpostimmuptest:
	mov	r6,r14
	ldr	r7,=unsignedbytes
	ldrb	r8,[r7],#1
	ldrb	r9,[r7]
	strb	r8,[r13],#1
	strb	r9,[r13]
	bl		strtrashregs
	sub	r13,r13,#1
	ldrb	r8,[r13],#1
	ldrb	r9,[r13]
	bl		ldrbstrbcheckregs
	mov	r15,r6
@==================================================================================================
strbpostimmdowntest:
	mov	r6,r14
	ldr	r7,=unsignedbytes
	add	r7,r7,#1
	ldrb	r9,[r7],#-1
	ldrb	r8,[r7]
	strb	r9,[r13],#-1
	strb	r8,[r13]
	bl		strtrashregs
	add	r13,r13,#1
	ldrb	r9,[r13],#-1
	ldrb	r8,[r13]
	bl		ldrbstrbcheckregs
	mov	r15,r6
@==================================================================================================
strbpostreguptest:
	mov	r6,r14
	ldr	r7,=unsignedbytes
	ldrb	r8,[r7],r1
	ldrb	r9,[r7]
	strb	r8,[r13],r1
	strb	r9,[r13]
	bl		strtrashregs
	sub	r13,r13,#1
	ldrb	r8,[r13],r1
	ldrb	r9,[r13]
	bl		ldrbstrbcheckregs
	mov	r15,r6
@==================================================================================================
strbpostregdowntest:
	mov	r6,r14
	ldr	r7,=unsignedbytes
	add	r7,r7,#1
	ldrb	r9,[r7],-r1
	ldrb	r8,[r7]
	strb	r9,[r13],-r1
	strb	r8,[r13]
	bl		strtrashregs
	add	r13,r13,#1
	ldrb	r9,[r13],-r1
	ldrb	r8,[r13]
	bl		ldrbstrbcheckregs
	mov	r15,r6
@==================================================================================================
inthandler:
	mov	r15,r14
@==================================================================================================
writestring:					@string address in r10
	mov	r0,r12,lsl #6
	add	r0,r0,#0x06000000	@vram address
	add	r12,r12,#1
writeloop:
	ldrb	r1,[r10],#1			@get char
	cmp	r1,#36				@is it a $
	strneh	r1,[r0],#2		@if not, write it
	bne	writeloop
	mov	r0,#0
	mov	r1,#1
	mov	r15,r14
@==================================================================================================
main:
	mov	r0,#0x03000000		@setup gba interrupt handler
	add	r0,r0,#0x8000
	ldr	r1,=inthandler
	str	r1,[r0,#-4]
	mov	r12,#0				@line pointer, dont touch
	mov	r0,#0x05000000		@init palette
	mov	r1,#0x3c00			@nice blue color...
	strh	r1,[r0]
	mvn	r1,r1					@...transforms into nice yellow color :D
	strh	r1,[r0,#2]
	mov	r0,#0x04000000		@set mode0
	mov	r1,#0x0100
	strh	r1,[r0]
	mov	r1,#4
	strh	r1,[r0,#8]
	mov	r0,#0x06000000
	orr	r0,r0,#0x4000
	add	r0,r0,#0x0420
	ldr	r1,=chardatasize
	ldr	r1,[r1]				@get size of chardata
	mov	r1,r1,lsr #1		@divide by 2
	ldr	r2,=chardata		@get address of chardata
copyloop:
	ldrh	r3,[r2],#2			@get a halfword
	strh	r3,[r0],#2			@store it into vram
	subs	r1,r1,#1
	bne	copyloop				@jump if not 0
	ldr	r10,=firststring
	bl		writestring	
	ldr	r10,=secondstring
	bl		writestring
	mov	r0,#0
	mov	r1,#1
	mov	r2,#2
	mov	r3,#4
	mov	r4,#0x7000
	mov	r5,#0xf000
	mov	r13,#0x03000000
	orr	r13,r13,#0x7f00
	ldr	r11,=testtable
testloop:
	ldr	r9,[r11],#4
	ldr	r10,[r11],#4
	cmp	r9,#0
	beq	done
	mov	r14,r15
	mov	r15,r9
	b		testloop
done:
	ldr	r10,=donestring
	bl		writestring
infloop:
	b		infloop
@==================================================================================================
unsignedhalfwords:
	.byte	0x00,0x70
	.byte	0x00,0xf0
@==================================================================================================
unsignedbytes:
	.byte	0x02
	.byte	0x04
@==================================================================================================
.align 4
	.byte 0x00
unalignedwords:
	.word	0x0000f000
	.word	0x00120078
@==================================================================================================
.align 4
testtable:
	.word	cmpregtest,cmpregstring
	.word	cmpimmtest,cmpimmstring
	.word	teqregtest,teqregstring
	.word	teqimmtest,teqimmstring
	.word stmia_ldmdbtest,stmia_ldmdbstring
	.word stmib_ldmdatest,stmib_ldmdastring
	.word stmda_ldmibtest,stmda_ldmibstring
	.word stmdb_ldmiatest,stmdb_ldmiastring
	.word	ldrpreimmuptest,ldrpreimmupstring
	.word	ldrpreimmdowntest,ldrpreimmdownstring
	.word	ldrprereguptest,ldrpreregupstring
	.word	ldrpreregdowntest,ldrpreregdownstring
	.word	ldrpreimmupwbtest,ldrpreimmupwbstring
	.word	ldrpreimmdownwbtest,ldrpreimmdownwbstring
	.word	ldrpreregupwbtest,ldrpreregupwbstring
	.word	ldrpreregdownwbtest,ldrpreregdownwbstring
	.word	ldrpostimmuptest,ldrpostimmupstring
	.word	ldrpostimmdowntest,ldrpostimmdownstring
	.word	ldrpostreguptest,ldrpostregupstring
	.word	ldrpostregdowntest,ldrpostregdownstring
	.word	strpreimmuptest,strpreimmupstring
	.word	strpreimmdowntest,strpreimmdownstring
	.word	strprereguptest,strpreregupstring
	.word	strpreregdowntest,strpreregdownstring
	.word	strpreimmupwbtest,strpreimmupwbstring
	.word	strpreimmdownwbtest,strpreimmdownwbstring
	.word	strpreregupwbtest,strpreregupwbstring
	.word	strpreregdownwbtest,strpreregdownwbstring
	.word	strpostimmuptest,strpostimmupstring
	.word	strpostimmdowntest,strpostimmdownstring
	.word	strpostreguptest,strpostregupstring
	.word	strpostregdowntest,strpostregdownstring
	.word	ldrbpreimmuptest,ldrbpreimmupstring
	.word	ldrbpreimmdowntest,ldrbpreimmdownstring
	.word	ldrbprereguptest,ldrbpreregupstring
	.word	ldrbpreregdowntest,ldrbpreregdownstring
	.word	ldrbpreimmupwbtest,ldrbpreimmupwbstring
	.word	ldrbpreimmdownwbtest,ldrbpreimmdownwbstring
	.word	ldrbpreregupwbtest,ldrbpreregupwbstring
	.word	ldrbpreregdownwbtest,ldrbpreregdownwbstring
	.word	ldrbpostimmuptest,ldrbpostimmupstring
	.word	ldrbpostimmdowntest,ldrbpostimmdownstring
	.word	ldrbpostreguptest,ldrbpostregupstring
	.word	ldrbpostregdowntest,ldrbpostregdownstring
	.word	strbpreimmuptest,strbpreimmupstring
	.word	strbpreimmdowntest,strbpreimmdownstring
	.word	strbprereguptest,strbpreregupstring
	.word	strbpreregdowntest,strbpreregdownstring
	.word	strbpreimmupwbtest,strbpreimmupwbstring
	.word	strbpreimmdownwbtest,strbpreimmdownwbstring
	.word	strbpreregupwbtest,strbpreregupwbstring
	.word	strbpreregdownwbtest,strbpreregdownwbstring
	.word	strbpostimmuptest,strbpostimmupstring
	.word	strbpostimmdowntest,strbpostimmdownstring
	.word	strbpostreguptest,strbpostregupstring
	.word	strbpostregdowntest,strbpostregdownstring
	.word ldrtest,ldrstring
	.word	0
@==================================================================================================
firststring:				.ascii	"    cputest - by Dead_Body$"
secondstring:				.ascii	"------------------------------$"
donestring:					.ascii	"done with tests$"
cmpregstring:				.ascii	"error: cmp reg flag setting$"
cmpimmstring:				.ascii	"error: cmp imm flag setting$"
teqregstring:				.ascii	"error: teq reg flag setting$"
teqimmstring:				.ascii	"error: teq imm flag setting$"
stmia_ldmdbstring:		.ascii	"error: stmia/ldmdb$"
stmib_ldmdastring:		.ascii	"error: stmib/ldmda$"
stmda_ldmibstring:		.ascii	"error: stmda/ldmib$"
stmdb_ldmiastring:		.ascii	"error: stmdb/ldmia$"
ldrpreimmupstring:		.ascii	"error: ldr pre imm up$"
ldrpreimmdownstring:		.ascii	"error: ldr pre imm down$"
ldrpreregupstring:		.ascii	"error: ldr pre reg up$"
ldrpreregdownstring:		.ascii	"error: ldr pre reg down$"
ldrpreimmupwbstring:		.ascii	"error: ldr pre imm up wb$"
ldrpreimmdownwbstring:	.ascii	"error: ldr pre imm down wb$"
ldrpreregupwbstring:		.ascii	"error: ldr pre reg up wb$"
ldrpreregdownwbstring:	.ascii	"error: ldr pre reg down wb$"
ldrpostimmupstring:		.ascii	"error: ldr post imm up$"
ldrpostimmdownstring:	.ascii	"error: ldr post imm down$"
ldrpostregupstring:		.ascii	"error: ldr post reg up$"
ldrpostregdownstring:	.ascii	"error: ldr post reg down$"
strpreimmupstring:		.ascii	"error: str pre imm up$"
strpreimmdownstring:		.ascii	"error: str pre imm down$"
strpreregupstring:		.ascii	"error: str pre reg up$"
strpreregdownstring:		.ascii	"error: str pre reg down$"
strpreimmupwbstring:		.ascii	"error: str pre imm up wb$"
strpreimmdownwbstring:	.ascii	"error: str pre imm down wb$"
strpreregupwbstring:		.ascii	"error: str pre reg up wb$"
strpreregdownwbstring:	.ascii	"error: str pre reg down wb$"
strpostimmupstring:		.ascii	"error: str post imm up$"
strpostimmdownstring:	.ascii	"error: str post imm down$"
strpostregupstring:		.ascii	"error: str post reg up$"
strpostregdownstring:	.ascii	"error: str post reg down$"
ldrbpreimmupstring:		.ascii	"error: ldrb pre imm up$"
ldrbpreimmdownstring:	.ascii	"error: ldrb pre imm down$"
ldrbpreregupstring:		.ascii	"error: ldrb pre reg up$"
ldrbpreregdownstring:	.ascii	"error: ldrb pre reg down$"
ldrbpreimmupwbstring:	.ascii	"error: ldrb pre imm up wb$"
ldrbpreimmdownwbstring:	.ascii	"error: ldrb pre imm down wb$"
ldrbpreregupwbstring:	.ascii	"error: ldrb pre reg up wb$"
ldrbpreregdownwbstring:	.ascii	"error: ldrb pre reg down wb$"
ldrbpostimmupstring:		.ascii	"error: ldrb post imm up$"
ldrbpostimmdownstring:	.ascii	"error: ldrb post imm down$"
ldrbpostregupstring:		.ascii	"error: ldrb post reg up$"
ldrbpostregdownstring:	.ascii	"error: ldrb post reg down$"
strbpreimmupstring:		.ascii	"error: strb pre imm up$"
strbpreimmdownstring:	.ascii	"error: strb pre imm down$"
strbpreregupstring:		.ascii	"error: strb pre reg up$"
strbpreregdownstring:	.ascii	"error: strb pre reg down$"
strbpreimmupwbstring:	.ascii	"error: strb pre imm up wb$"
strbpreimmdownwbstring:	.ascii	"error: strb pre imm down wb$"
strbpreregupwbstring:	.ascii	"error: strb pre reg up wb$"
strbpreregdownwbstring:	.ascii	"error: strb pre reg down wb$"
strbpostimmupstring:		.ascii	"error: strb post imm up$"
strbpostimmdownstring:	.ascii	"error: strb post imm down$"
strbpostregupstring:		.ascii	"error: strb post reg up$"
strbpostregdownstring:	.ascii	"error: strb post reg down$"
ldrstring:					.ascii	"error: unaligned ldr writes$"
@==================================================================================================
